/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set Heat aliases
#define Heat_TRIS                 TRISAbits.TRISA3
#define Heat_LAT                  LATAbits.LATA3
#define Heat_PORT                 PORTAbits.RA3
#define Heat_WPU                  WPUAbits.WPUA3
#define Heat_OD                   ODCONAbits.ODA3
#define Heat_ANS                  ANSELAbits.ANSA3
#define Heat_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define Heat_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define Heat_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define Heat_GetValue()           PORTAbits.RA3
#define Heat_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define Heat_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define Heat_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define Heat_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define Heat_SetPushPull()        do { ODCONAbits.ODA3 = 0; } while(0)
#define Heat_SetOpenDrain()       do { ODCONAbits.ODA3 = 1; } while(0)
#define Heat_SetAnalogMode()      do { ANSELAbits.ANSA3 = 1; } while(0)
#define Heat_SetDigitalMode()     do { ANSELAbits.ANSA3 = 0; } while(0)

// get/set Sensor aliases
#define Sensor_TRIS                 TRISAbits.TRISA4
#define Sensor_LAT                  LATAbits.LATA4
#define Sensor_PORT                 PORTAbits.RA4
#define Sensor_WPU                  WPUAbits.WPUA4
#define Sensor_OD                   ODCONAbits.ODA4
#define Sensor_ANS                  ANSELAbits.ANSA4
#define Sensor_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define Sensor_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define Sensor_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define Sensor_GetValue()           PORTAbits.RA4
#define Sensor_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define Sensor_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define Sensor_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define Sensor_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define Sensor_SetPushPull()        do { ODCONAbits.ODA4 = 0; } while(0)
#define Sensor_SetOpenDrain()       do { ODCONAbits.ODA4 = 1; } while(0)
#define Sensor_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define Sensor_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set Mesure aliases
#define Mesure_TRIS                 TRISAbits.TRISA5
#define Mesure_LAT                  LATAbits.LATA5
#define Mesure_PORT                 PORTAbits.RA5
#define Mesure_WPU                  WPUAbits.WPUA5
#define Mesure_OD                   ODCONAbits.ODA5
#define Mesure_ANS                  ANSELAbits.ANSA5
#define Mesure_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define Mesure_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define Mesure_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define Mesure_GetValue()           PORTAbits.RA5
#define Mesure_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define Mesure_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define Mesure_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define Mesure_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define Mesure_SetPushPull()        do { ODCONAbits.ODA5 = 0; } while(0)
#define Mesure_SetOpenDrain()       do { ODCONAbits.ODA5 = 1; } while(0)
#define Mesure_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define Mesure_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/