/***********************************************
*  t\탉Cu
*  I2CC^[tF[X
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(data) ----- P\o
*    lcd_str(ptr)  ----- \o
*    lcd_clear()   ----- S
**********************************************/
#include "lcd_lib2.h"
#include "i2c_lib2.h"

I2C_MESSAGE_STATUS   status;
/*********************************
* t1\f[^o
*********************************/
void lcd_data(uint8_t data)
{
    uint8_t tbuf[2];
    tbuf[0] = 0x40;
    tbuf[1] = data;
    I2C_MasterWrite(tbuf, 2, 0x3E, &status);
    while(status == I2C_MESSAGE_PENDING);
    __delay_us(30);             // x
}

/*******************************
* tւPR}ho
*******************************/
void lcd_cmd(uint8_t cmd)
{
    uint8_t tbuf[2];
    tbuf[0] = 0x00;
    tbuf[1] = cmd;
    I2C_MasterWrite(tbuf, 2, 0x3E, &status);
    while(status == I2C_MESSAGE_PENDING);
    /* ClearHome */
    if((cmd == 0x01)||(cmd == 0x02))
        __delay_ms(2);          // 2msec҂
    else
        __delay_us(30);         // 30sec҂
}
/*******************************
*  ֐
*******************************/
void lcd_init(void)
{
    __delay_ms(150);        // ҂
    lcd_cmd(0x38);          // 8bit 2line Normal mode
    lcd_cmd(0x39);          // 8bit 2line Extend mode
    lcd_cmd(0x14);          // OSC 183Hz BIAS 1/5
    lcd_cmd(0x7F);          // Contrast Set
    /*** {H̃IItݒ 3.3V/5VŐؑ֕Kv */   
//    lcd_cmd(0x5E);          //Booster on 3.3V
    lcd_cmd(0x5B);          // Booster Off 5V
    /*******************/
    lcd_cmd(0x6B);          // Follower
    __delay_ms(300);
    lcd_cmd(0x38);          // Set Normal mode
    lcd_cmd(0x0C);          // Display On
    lcd_cmd(0x01);          // Clear Display
}
/******************************
* S֐
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);          //R}ho
}
/*****************************
* \֐
*****************************/
void lcd_str(const uint8_t* ptr)
{
    while(*ptr != 0)            //o
        lcd_data(*ptr++);       //\
}
/*****************************
*  ACR\֐
*****************************/
void lcd_icon(uint16_t num, uint8_t onoff)
{
    lcd_cmd(0x39);                      // Extend mode
    lcd_cmd(0x40 + ICON[num][0]);       // ACRAhXw
    if(onoff)
        lcd_data(ICON[num][1]);         // ACRIf[^
    else
        lcd_data(0x00);                 // ACRItf[^
    lcd_cmd(0x38);                      // Normal Mode
}
