/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set IO aliases
#define IO_TRIS                 TRISAbits.TRISA0
#define IO_LAT                  LATAbits.LATA0
#define IO_PORT                 PORTAbits.RA0
#define IO_WPU                  WPUAbits.WPUA0
#define IO_OD                   ODCONAbits.ODA0
#define IO_ANS                  ANSELAbits.ANSA0
#define IO_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define IO_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define IO_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define IO_GetValue()           PORTAbits.RA0
#define IO_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define IO_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define IO_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define IO_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define IO_SetPushPull()        do { ODCONAbits.ODA0 = 0; } while(0)
#define IO_SetOpenDrain()       do { ODCONAbits.ODA0 = 1; } while(0)
#define IO_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define IO_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set SDA aliases
#define SDA_TRIS                 TRISCbits.TRISC0
#define SDA_LAT                  LATCbits.LATC0
#define SDA_PORT                 PORTCbits.RC0
#define SDA_WPU                  WPUCbits.WPUC0
#define SDA_OD                   ODCONCbits.ODC0
#define SDA_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define SDA_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define SDA_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define SDA_GetValue()           PORTCbits.RC0
#define SDA_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define SDA_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define SDA_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define SDA_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define SDA_SetPushPull()        do { ODCONCbits.ODC0 = 0; } while(0)
#define SDA_SetOpenDrain()       do { ODCONCbits.ODC0 = 1; } while(0)

// get/set SCK aliases
#define SCK_TRIS                 TRISCbits.TRISC1
#define SCK_LAT                  LATCbits.LATC1
#define SCK_PORT                 PORTCbits.RC1
#define SCK_WPU                  WPUCbits.WPUC1
#define SCK_OD                   ODCONCbits.ODC1
#define SCK_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define SCK_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define SCK_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define SCK_GetValue()           PORTCbits.RC1
#define SCK_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define SCK_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define SCK_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define SCK_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define SCK_SetPushPull()        do { ODCONCbits.ODC1 = 0; } while(0)
#define SCK_SetOpenDrain()       do { ODCONCbits.ODC1 = 1; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/