/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set AN0 aliases
#define AN0_TRIS                 TRISAbits.TRISA0
#define AN0_LAT                  LATAbits.LATA0
#define AN0_PORT                 PORTAbits.RA0
#define AN0_WPU                  WPUAbits.WPUA0
#define AN0_OD                   ODCONAbits.ODA0
#define AN0_ANS                  ANSELAbits.ANSA0
#define AN0_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define AN0_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define AN0_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define AN0_GetValue()           PORTAbits.RA0
#define AN0_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define AN0_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define AN0_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define AN0_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define AN0_SetPushPull()        do { ODCONAbits.ODA0 = 0; } while(0)
#define AN0_SetOpenDrain()       do { ODCONAbits.ODA0 = 1; } while(0)
#define AN0_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define AN0_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set AN1 aliases
#define AN1_TRIS                 TRISAbits.TRISA1
#define AN1_LAT                  LATAbits.LATA1
#define AN1_PORT                 PORTAbits.RA1
#define AN1_WPU                  WPUAbits.WPUA1
#define AN1_OD                   ODCONAbits.ODA1
#define AN1_ANS                  ANSELAbits.ANSA1
#define AN1_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define AN1_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define AN1_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define AN1_GetValue()           PORTAbits.RA1
#define AN1_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define AN1_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define AN1_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define AN1_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define AN1_SetPushPull()        do { ODCONAbits.ODA1 = 0; } while(0)
#define AN1_SetOpenDrain()       do { ODCONAbits.ODA1 = 1; } while(0)
#define AN1_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define AN1_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set AN2 aliases
#define AN2_TRIS                 TRISAbits.TRISA2
#define AN2_LAT                  LATAbits.LATA2
#define AN2_PORT                 PORTAbits.RA2
#define AN2_WPU                  WPUAbits.WPUA2
#define AN2_OD                   ODCONAbits.ODA2
#define AN2_ANS                  ANSELAbits.ANSA2
#define AN2_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define AN2_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define AN2_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define AN2_GetValue()           PORTAbits.RA2
#define AN2_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define AN2_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define AN2_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define AN2_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define AN2_SetPushPull()        do { ODCONAbits.ODA2 = 0; } while(0)
#define AN2_SetOpenDrain()       do { ODCONAbits.ODA2 = 1; } while(0)
#define AN2_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define AN2_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set RC4 procedures
#define RC4_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define RC4_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define RC4_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define RC4_GetValue()              PORTCbits.RC4
#define RC4_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define RC4_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define RC4_SetPullup()             do { WPUCbits.WPUC4 = 1; } while(0)
#define RC4_ResetPullup()           do { WPUCbits.WPUC4 = 0; } while(0)
#define RC4_SetAnalogMode()         do { ANSELCbits.ANSC4 = 1; } while(0)
#define RC4_SetDigitalMode()        do { ANSELCbits.ANSC4 = 0; } while(0)

// get/set RC5 procedures
#define RC5_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define RC5_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define RC5_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define RC5_GetValue()              PORTCbits.RC5
#define RC5_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define RC5_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define RC5_SetPullup()             do { WPUCbits.WPUC5 = 1; } while(0)
#define RC5_ResetPullup()           do { WPUCbits.WPUC5 = 0; } while(0)
#define RC5_SetAnalogMode()         do { ANSELCbits.ANSC5 = 1; } while(0)
#define RC5_SetDigitalMode()        do { ANSELCbits.ANSC5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/