/***************************************
 * @^OtBbNLCDpCu
 *@@128~8hbg~6̍\
 ***************************************/
#include "GraphicLCD.h"
/***********************************
 * Sʏ
 ***********************************/
void lcd_clear(void){
    uint8_t i, j;
    
    for(i=0; i<8; i++){     // SRAM
        SPICmd(0xB0 | i);   // Pagew
        SPICmd(0x10);       // Colum
        SPICmd(0);          // Colum 
        for(j=0; j<128; j++)// 128BJԂ
            SPIData(0);     // 0̏
    }
    SPICmd(0x40);           // RAMŏ    
}
/************************************
 * Pixel\
 *  X<128  Y<48
 ********************************/
void Pixel(uint8_t xpos, uint8_t ypos){
    uint8_t pos;
    
    SPICmd(0xB0 | (ypos / 8));  // ypos  page
    SPICmd(0x10 | (xpos >> 4)); // Xpos Upper
    SPICmd(0x00 | (xpos & 0x0F));// Xpos lower
    pos = 0x01;                 // 1rbg
    SPIData(pos << (ypos % 8)); // yposVtg
     SPICmd(0x40);              // RAM ŏ
}
/*************************************
 * 8x8̕\fwꏊɕ\
 * @X<16@Y<6
 **********************************/
void Image(uint8_t xpos, uint8_t ypos, uint8_t* image){
    uint8_t i, j;
    
    SPICmd(0xB0 | ypos);    // pagew
    SPICmd(0x10 | ((xpos * 8) >> 4));
    SPICmd(0x00 | ((xpos * 8) & 0x0F));
    for(i=0; i<8; i++)      // 8BJԂ
        SPIData(*image++);  // C[W
    SPICmd(0x40);           // RAMŏ  
}
/**************************************
 *  1y[WA\
 **************************************/
void DisplayPage(uint8_t page, uint8_t* buf){
    int i;
    
    SPICmd(0xB0 | page);    // Pagew
    SPICmd(0x10);           // Colum 0
    SPICmd(0);              // Coum
    for(i=0; i<128; i++)    // 128BJԂ
        SPIData(*buf++);    // obt@
    SPICmd(0x40);           // RAMŏ   
}
/****************************************
 * ֐
 ***************************************/
void lcd_init(void){
    __delay_ms(10);
    SPICmd(0xAE);       // Display Off
    SPICmd(0xA0);       // ADC Normal
    SPICmd(0xC8);       // Common Output Reverse
    SPICmd(0xA3);       // Bias 1/7
    SPICmd(0x2C);       // Power Control1
    __delay_ms(2);
    SPICmd(0x2E);       // Power Control2
    __delay_ms(2);
    SPICmd(0x2F);       // Power Control3
    SPICmd(0x23);       // Contrast Vo ratio
    SPICmd(0x81);       // Electric Volume
    SPICmd(0x1C);       // Electric Volume
    SPICmd(0xA4);       // S
    SPICmd(0x40);       // Start 0 line
    SPICmd(0xA6);       // Diplay Normal
    SPICmd(0xAF);       // Diplay On
}
/*****************************
 * SPIŃR}ho
 ****************************/
void SPICmd(uint8_t cmd){
    CS_SetLow();            // CS Low
    RS_SetLow();            // RS LowR}h
    SPI_Exchange8bit(cmd);  // ݒf[^M
    CS_SetHigh();           // CS High
}
/****************************
 * SPIŕ\f[^o
 ***************************/
void SPIData(uint8_t data){
    CS_SetLow();            // CS Low
    RS_SetHigh();           // RS High f[^
    SPI_Exchange8bit(data); // \f[^M
    CS_SetHigh();           // CSHigh
}
