/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set RS aliases
#define RS_TRIS                 TRISBbits.TRISB0
#define RS_LAT                  LATBbits.LATB0
#define RS_PORT                 PORTBbits.RB0
#define RS_WPU                  WPUBbits.WPUB0
#define RS_ANS                  ANSELBbits.ANSB0
#define RS_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define RS_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define RS_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define RS_GetValue()           PORTBbits.RB0
#define RS_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define RS_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define RS_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define RS_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define RS_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define RS_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set E aliases
#define E_TRIS                 TRISBbits.TRISB1
#define E_LAT                  LATBbits.LATB1
#define E_PORT                 PORTBbits.RB1
#define E_WPU                  WPUBbits.WPUB1
#define E_ANS                  ANSELBbits.ANSB1
#define E_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define E_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define E_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define E_GetValue()           PORTBbits.RB1
#define E_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define E_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define E_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define E_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define E_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define E_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set IO_RB2 aliases
#define IO_RB2_TRIS                 TRISBbits.TRISB2
#define IO_RB2_LAT                  LATBbits.LATB2
#define IO_RB2_PORT                 PORTBbits.RB2
#define IO_RB2_WPU                  WPUBbits.WPUB2
#define IO_RB2_ANS                  ANSELBbits.ANSB2
#define IO_RB2_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define IO_RB2_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define IO_RB2_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define IO_RB2_GetValue()           PORTBbits.RB2
#define IO_RB2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define IO_RB2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define IO_RB2_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define IO_RB2_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define IO_RB2_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define IO_RB2_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set DB3 aliases
#define DB3_TRIS                 TRISBbits.TRISB3
#define DB3_LAT                  LATBbits.LATB3
#define DB3_PORT                 PORTBbits.RB3
#define DB3_WPU                  WPUBbits.WPUB3
#define DB3_ANS                  ANSELBbits.ANSB3
#define DB3_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define DB3_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define DB3_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define DB3_GetValue()           PORTBbits.RB3
#define DB3_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define DB3_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define DB3_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define DB3_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define DB3_SetAnalogMode()      do { ANSELBbits.ANSB3 = 1; } while(0)
#define DB3_SetDigitalMode()     do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set DB4 aliases
#define DB4_TRIS                 TRISBbits.TRISB4
#define DB4_LAT                  LATBbits.LATB4
#define DB4_PORT                 PORTBbits.RB4
#define DB4_WPU                  WPUBbits.WPUB4
#define DB4_OD                   ODCONBbits.ODB4
#define DB4_ANS                  ANSELBbits.ANSB4
#define DB4_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define DB4_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define DB4_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define DB4_GetValue()           PORTBbits.RB4
#define DB4_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define DB4_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define DB4_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define DB4_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define DB4_SetPushPull()        do { ODCONBbits.ODB4 = 0; } while(0)
#define DB4_SetOpenDrain()       do { ODCONBbits.ODB4 = 1; } while(0)
#define DB4_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define DB4_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set DB5 aliases
#define DB5_TRIS                 TRISBbits.TRISB5
#define DB5_LAT                  LATBbits.LATB5
#define DB5_PORT                 PORTBbits.RB5
#define DB5_WPU                  WPUBbits.WPUB5
#define DB5_OD                   ODCONBbits.ODB5
#define DB5_ANS                  ANSELBbits.ANSB5
#define DB5_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define DB5_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define DB5_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define DB5_GetValue()           PORTBbits.RB5
#define DB5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define DB5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define DB5_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define DB5_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define DB5_SetPushPull()        do { ODCONBbits.ODB5 = 0; } while(0)
#define DB5_SetOpenDrain()       do { ODCONBbits.ODB5 = 1; } while(0)
#define DB5_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define DB5_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set DB6 aliases
#define DB6_TRIS                 TRISBbits.TRISB6
#define DB6_LAT                  LATBbits.LATB6
#define DB6_PORT                 PORTBbits.RB6
#define DB6_WPU                  WPUBbits.WPUB6
#define DB6_OD                   ODCONBbits.ODB6
#define DB6_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define DB6_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define DB6_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define DB6_GetValue()           PORTBbits.RB6
#define DB6_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define DB6_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define DB6_SetPullup()          do { WPUBbits.WPUB6 = 1; } while(0)
#define DB6_ResetPullup()        do { WPUBbits.WPUB6 = 0; } while(0)
#define DB6_SetPushPull()        do { ODCONBbits.ODB6 = 0; } while(0)
#define DB6_SetOpenDrain()       do { ODCONBbits.ODB6 = 1; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/