/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set S1 aliases
#define S1_TRIS                 TRISAbits.TRISA6
#define S1_LAT                  LATAbits.LATA6
#define S1_PORT                 PORTAbits.RA6
#define S1_WPU                  WPUAbits.WPUA6
#define S1_OD                   ODCONAbits.ODA6
#define S1_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define S1_GetValue()           PORTAbits.RA6
#define S1_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define S1_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define S1_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define S1_SetPushPull()        do { ODCONAbits.ODA6 = 0; } while(0)
#define S1_SetOpenDrain()       do { ODCONAbits.ODA6 = 1; } while(0)

// get/set S2 aliases
#define S2_TRIS                 TRISAbits.TRISA7
#define S2_LAT                  LATAbits.LATA7
#define S2_PORT                 PORTAbits.RA7
#define S2_WPU                  WPUAbits.WPUA7
#define S2_OD                   ODCONAbits.ODA7
#define S2_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define S2_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define S2_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define S2_GetValue()           PORTAbits.RA7
#define S2_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define S2_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define S2_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define S2_SetPushPull()        do { ODCONAbits.ODA7 = 0; } while(0)
#define S2_SetOpenDrain()       do { ODCONAbits.ODA7 = 1; } while(0)

// get/set LED aliases
#define LED_TRIS                 TRISBbits.TRISB4
#define LED_LAT                  LATBbits.LATB4
#define LED_PORT                 PORTBbits.RB4
#define LED_WPU                  WPUBbits.WPUB4
#define LED_OD                   ODCONBbits.ODB4
#define LED_ANS                  ANSELBbits.ANSB4
#define LED_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define LED_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define LED_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define LED_GetValue()           PORTBbits.RB4
#define LED_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define LED_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define LED_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define LED_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define LED_SetPushPull()        do { ODCONBbits.ODB4 = 0; } while(0)
#define LED_SetOpenDrain()       do { ODCONBbits.ODB4 = 1; } while(0)
#define LED_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define LED_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/