/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set S2 aliases
#define S2_TRIS                 TRISAbits.TRISA6
#define S2_LAT                  LATAbits.LATA6
#define S2_PORT                 PORTAbits.RA6
#define S2_WPU                  WPUAbits.WPUA6
#define S2_OD                   ODCONAbits.ODA6
#define S2_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define S2_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define S2_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define S2_GetValue()           PORTAbits.RA6
#define S2_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define S2_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define S2_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define S2_SetPushPull()        do { ODCONAbits.ODA6 = 0; } while(0)
#define S2_SetOpenDrain()       do { ODCONAbits.ODA6 = 1; } while(0)

// get/set S1 aliases
#define S1_TRIS                 TRISAbits.TRISA7
#define S1_LAT                  LATAbits.LATA7
#define S1_PORT                 PORTAbits.RA7
#define S1_WPU                  WPUAbits.WPUA7
#define S1_OD                   ODCONAbits.ODA7
#define S1_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define S1_GetValue()           PORTAbits.RA7
#define S1_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define S1_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define S1_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define S1_SetPushPull()        do { ODCONAbits.ODA7 = 0; } while(0)
#define S1_SetOpenDrain()       do { ODCONAbits.ODA7 = 1; } while(0)

// get/set RL2 aliases
#define RL2_TRIS                 TRISBbits.TRISB0
#define RL2_LAT                  LATBbits.LATB0
#define RL2_PORT                 PORTBbits.RB0
#define RL2_WPU                  WPUBbits.WPUB0
#define RL2_ANS                  ANSELBbits.ANSB0
#define RL2_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define RL2_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define RL2_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define RL2_GetValue()           PORTBbits.RB0
#define RL2_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define RL2_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define RL2_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define RL2_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define RL2_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define RL2_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set RL1 aliases
#define RL1_TRIS                 TRISBbits.TRISB1
#define RL1_LAT                  LATBbits.LATB1
#define RL1_PORT                 PORTBbits.RB1
#define RL1_WPU                  WPUBbits.WPUB1
#define RL1_ANS                  ANSELBbits.ANSB1
#define RL1_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define RL1_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define RL1_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define RL1_GetValue()           PORTBbits.RB1
#define RL1_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define RL1_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define RL1_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define RL1_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define RL1_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define RL1_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/