/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set R1 aliases
#define R1_TRIS                 TRISAbits.TRISA0
#define R1_LAT                  LATAbits.LATA0
#define R1_PORT                 PORTAbits.RA0
#define R1_WPU                  WPUAbits.WPUA0
#define R1_OD                   ODCONAbits.ODA0
#define R1_ANS                  ANSELAbits.ANSA0
#define R1_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define R1_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define R1_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define R1_GetValue()           PORTAbits.RA0
#define R1_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define R1_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define R1_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define R1_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define R1_SetPushPull()        do { ODCONAbits.ODA0 = 0; } while(0)
#define R1_SetOpenDrain()       do { ODCONAbits.ODA0 = 1; } while(0)
#define R1_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define R1_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set R2 aliases
#define R2_TRIS                 TRISAbits.TRISA1
#define R2_LAT                  LATAbits.LATA1
#define R2_PORT                 PORTAbits.RA1
#define R2_WPU                  WPUAbits.WPUA1
#define R2_OD                   ODCONAbits.ODA1
#define R2_ANS                  ANSELAbits.ANSA1
#define R2_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define R2_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define R2_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define R2_GetValue()           PORTAbits.RA1
#define R2_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define R2_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define R2_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define R2_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define R2_SetPushPull()        do { ODCONAbits.ODA1 = 0; } while(0)
#define R2_SetOpenDrain()       do { ODCONAbits.ODA1 = 1; } while(0)
#define R2_SetAnalogMode()      do { ANSELAbits.ANSA1 = 1; } while(0)
#define R2_SetDigitalMode()     do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set R3 aliases
#define R3_TRIS                 TRISAbits.TRISA2
#define R3_LAT                  LATAbits.LATA2
#define R3_PORT                 PORTAbits.RA2
#define R3_WPU                  WPUAbits.WPUA2
#define R3_OD                   ODCONAbits.ODA2
#define R3_ANS                  ANSELAbits.ANSA2
#define R3_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define R3_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define R3_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define R3_GetValue()           PORTAbits.RA2
#define R3_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define R3_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define R3_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define R3_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define R3_SetPushPull()        do { ODCONAbits.ODA2 = 0; } while(0)
#define R3_SetOpenDrain()       do { ODCONAbits.ODA2 = 1; } while(0)
#define R3_SetAnalogMode()      do { ANSELAbits.ANSA2 = 1; } while(0)
#define R3_SetDigitalMode()     do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set R4 aliases
#define R4_TRIS                 TRISAbits.TRISA3
#define R4_LAT                  LATAbits.LATA3
#define R4_PORT                 PORTAbits.RA3
#define R4_WPU                  WPUAbits.WPUA3
#define R4_OD                   ODCONAbits.ODA3
#define R4_ANS                  ANSELAbits.ANSA3
#define R4_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define R4_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define R4_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define R4_GetValue()           PORTAbits.RA3
#define R4_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define R4_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define R4_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define R4_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define R4_SetPushPull()        do { ODCONAbits.ODA3 = 0; } while(0)
#define R4_SetOpenDrain()       do { ODCONAbits.ODA3 = 1; } while(0)
#define R4_SetAnalogMode()      do { ANSELAbits.ANSA3 = 1; } while(0)
#define R4_SetDigitalMode()     do { ANSELAbits.ANSA3 = 0; } while(0)

// get/set C1 aliases
#define C1_TRIS                 TRISAbits.TRISA4
#define C1_LAT                  LATAbits.LATA4
#define C1_PORT                 PORTAbits.RA4
#define C1_WPU                  WPUAbits.WPUA4
#define C1_OD                   ODCONAbits.ODA4
#define C1_ANS                  ANSELAbits.ANSA4
#define C1_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define C1_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define C1_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define C1_GetValue()           PORTAbits.RA4
#define C1_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define C1_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define C1_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define C1_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define C1_SetPushPull()        do { ODCONAbits.ODA4 = 0; } while(0)
#define C1_SetOpenDrain()       do { ODCONAbits.ODA4 = 1; } while(0)
#define C1_SetAnalogMode()      do { ANSELAbits.ANSA4 = 1; } while(0)
#define C1_SetDigitalMode()     do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set C2 aliases
#define C2_TRIS                 TRISAbits.TRISA5
#define C2_LAT                  LATAbits.LATA5
#define C2_PORT                 PORTAbits.RA5
#define C2_WPU                  WPUAbits.WPUA5
#define C2_OD                   ODCONAbits.ODA5
#define C2_ANS                  ANSELAbits.ANSA5
#define C2_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define C2_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define C2_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define C2_GetValue()           PORTAbits.RA5
#define C2_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define C2_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define C2_SetPullup()          do { WPUAbits.WPUA5 = 1; } while(0)
#define C2_ResetPullup()        do { WPUAbits.WPUA5 = 0; } while(0)
#define C2_SetPushPull()        do { ODCONAbits.ODA5 = 0; } while(0)
#define C2_SetOpenDrain()       do { ODCONAbits.ODA5 = 1; } while(0)
#define C2_SetAnalogMode()      do { ANSELAbits.ANSA5 = 1; } while(0)
#define C2_SetDigitalMode()     do { ANSELAbits.ANSA5 = 0; } while(0)

// get/set C3 aliases
#define C3_TRIS                 TRISAbits.TRISA6
#define C3_LAT                  LATAbits.LATA6
#define C3_PORT                 PORTAbits.RA6
#define C3_WPU                  WPUAbits.WPUA6
#define C3_OD                   ODCONAbits.ODA6
#define C3_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define C3_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define C3_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define C3_GetValue()           PORTAbits.RA6
#define C3_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define C3_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define C3_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define C3_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define C3_SetPushPull()        do { ODCONAbits.ODA6 = 0; } while(0)
#define C3_SetOpenDrain()       do { ODCONAbits.ODA6 = 1; } while(0)

// get/set C4 aliases
#define C4_TRIS                 TRISAbits.TRISA7
#define C4_LAT                  LATAbits.LATA7
#define C4_PORT                 PORTAbits.RA7
#define C4_WPU                  WPUAbits.WPUA7
#define C4_OD                   ODCONAbits.ODA7
#define C4_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define C4_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define C4_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define C4_GetValue()           PORTAbits.RA7
#define C4_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define C4_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define C4_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define C4_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define C4_SetPushPull()        do { ODCONAbits.ODA7 = 0; } while(0)
#define C4_SetOpenDrain()       do { ODCONAbits.ODA7 = 1; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/