/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set CS aliases
#define CS_TRIS                 TRISBbits.TRISB1
#define CS_LAT                  LATBbits.LATB1
#define CS_PORT                 PORTBbits.RB1
#define CS_WPU                  WPUBbits.WPUB1
#define CS_ANS                  ANSELBbits.ANSB1
#define CS_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define CS_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define CS_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define CS_GetValue()           PORTBbits.RB1
#define CS_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define CS_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define CS_SetPullup()          do { WPUBbits.WPUB1 = 1; } while(0)
#define CS_ResetPullup()        do { WPUBbits.WPUB1 = 0; } while(0)
#define CS_SetAnalogMode()      do { ANSELBbits.ANSB1 = 1; } while(0)
#define CS_SetDigitalMode()     do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set SCK aliases
#define SCK_TRIS                 TRISBbits.TRISB2
#define SCK_LAT                  LATBbits.LATB2
#define SCK_PORT                 PORTBbits.RB2
#define SCK_WPU                  WPUBbits.WPUB2
#define SCK_ANS                  ANSELBbits.ANSB2
#define SCK_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define SCK_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define SCK_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define SCK_GetValue()           PORTBbits.RB2
#define SCK_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define SCK_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define SCK_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define SCK_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define SCK_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define SCK_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set SDO aliases
#define SDO_TRIS                 TRISBbits.TRISB3
#define SDO_LAT                  LATBbits.LATB3
#define SDO_PORT                 PORTBbits.RB3
#define SDO_WPU                  WPUBbits.WPUB3
#define SDO_ANS                  ANSELBbits.ANSB3
#define SDO_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define SDO_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define SDO_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define SDO_GetValue()           PORTBbits.RB3
#define SDO_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define SDO_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define SDO_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define SDO_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define SDO_SetAnalogMode()      do { ANSELBbits.ANSB3 = 1; } while(0)
#define SDO_SetDigitalMode()     do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set SDI aliases
#define SDI_TRIS                 TRISBbits.TRISB4
#define SDI_LAT                  LATBbits.LATB4
#define SDI_PORT                 PORTBbits.RB4
#define SDI_WPU                  WPUBbits.WPUB4
#define SDI_OD                   ODCONBbits.ODB4
#define SDI_ANS                  ANSELBbits.ANSB4
#define SDI_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define SDI_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define SDI_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define SDI_GetValue()           PORTBbits.RB4
#define SDI_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define SDI_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define SDI_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define SDI_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define SDI_SetPushPull()        do { ODCONBbits.ODB4 = 0; } while(0)
#define SDI_SetOpenDrain()       do { ODCONBbits.ODB4 = 1; } while(0)
#define SDI_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define SDI_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set CE aliases
#define CE_TRIS                 TRISBbits.TRISB5
#define CE_LAT                  LATBbits.LATB5
#define CE_PORT                 PORTBbits.RB5
#define CE_WPU                  WPUBbits.WPUB5
#define CE_OD                   ODCONBbits.ODB5
#define CE_ANS                  ANSELBbits.ANSB5
#define CE_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define CE_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define CE_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define CE_GetValue()           PORTBbits.RB5
#define CE_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define CE_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define CE_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define CE_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define CE_SetPushPull()        do { ODCONBbits.ODB5 = 0; } while(0)
#define CE_SetOpenDrain()       do { ODCONBbits.ODB5 = 1; } while(0)
#define CE_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define CE_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define RC6_SetPullup()             do { WPUCbits.WPUC6 = 1; } while(0)
#define RC6_ResetPullup()           do { WPUCbits.WPUC6 = 0; } while(0)
#define RC6_SetAnalogMode()         do { ANSELCbits.ANSC6 = 1; } while(0)
#define RC6_SetDigitalMode()        do { ANSELCbits.ANSC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define RC7_SetPullup()             do { WPUCbits.WPUC7 = 1; } while(0)
#define RC7_ResetPullup()           do { WPUCbits.WPUC7 = 0; } while(0)
#define RC7_SetAnalogMode()         do { ANSELCbits.ANSC7 = 1; } while(0)
#define RC7_SetDigitalMode()        do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/