/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set ERR aliases
#define ERR_TRIS                 TRISCbits.TRISC0
#define ERR_LAT                  LATCbits.LATC0
#define ERR_PORT                 PORTCbits.RC0
#define ERR_WPU                  WPUCbits.WPUC0
#define ERR_OD                   ODCONCbits.ODC0
#define ERR_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define ERR_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define ERR_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define ERR_GetValue()           PORTCbits.RC0
#define ERR_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define ERR_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define ERR_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define ERR_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define ERR_SetPushPull()        do { ODCONCbits.ODC0 = 0; } while(0)
#define ERR_SetOpenDrain()       do { ODCONCbits.ODC0 = 1; } while(0)

// get/set LED1 aliases
#define LED1_TRIS                 TRISCbits.TRISC1
#define LED1_LAT                  LATCbits.LATC1
#define LED1_PORT                 PORTCbits.RC1
#define LED1_WPU                  WPUCbits.WPUC1
#define LED1_OD                   ODCONCbits.ODC1
#define LED1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define LED1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define LED1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define LED1_GetValue()           PORTCbits.RC1
#define LED1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define LED1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define LED1_SetPullup()          do { WPUCbits.WPUC1 = 1; } while(0)
#define LED1_ResetPullup()        do { WPUCbits.WPUC1 = 0; } while(0)
#define LED1_SetPushPull()        do { ODCONCbits.ODC1 = 0; } while(0)
#define LED1_SetOpenDrain()       do { ODCONCbits.ODC1 = 1; } while(0)

// get/set LED2 aliases
#define LED2_TRIS                 TRISCbits.TRISC2
#define LED2_LAT                  LATCbits.LATC2
#define LED2_PORT                 PORTCbits.RC2
#define LED2_WPU                  WPUCbits.WPUC2
#define LED2_OD                   ODCONCbits.ODC2
#define LED2_ANS                  ANSELCbits.ANSC2
#define LED2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define LED2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define LED2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define LED2_GetValue()           PORTCbits.RC2
#define LED2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define LED2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define LED2_SetPullup()          do { WPUCbits.WPUC2 = 1; } while(0)
#define LED2_ResetPullup()        do { WPUCbits.WPUC2 = 0; } while(0)
#define LED2_SetPushPull()        do { ODCONCbits.ODC2 = 0; } while(0)
#define LED2_SetOpenDrain()       do { ODCONCbits.ODC2 = 1; } while(0)
#define LED2_SetAnalogMode()      do { ANSELCbits.ANSC2 = 1; } while(0)
#define LED2_SetDigitalMode()     do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set LED3 aliases
#define LED3_TRIS                 TRISCbits.TRISC3
#define LED3_LAT                  LATCbits.LATC3
#define LED3_PORT                 PORTCbits.RC3
#define LED3_WPU                  WPUCbits.WPUC3
#define LED3_OD                   ODCONCbits.ODC3
#define LED3_ANS                  ANSELCbits.ANSC3
#define LED3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define LED3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define LED3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define LED3_GetValue()           PORTCbits.RC3
#define LED3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define LED3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define LED3_SetPullup()          do { WPUCbits.WPUC3 = 1; } while(0)
#define LED3_ResetPullup()        do { WPUCbits.WPUC3 = 0; } while(0)
#define LED3_SetPushPull()        do { ODCONCbits.ODC3 = 0; } while(0)
#define LED3_SetOpenDrain()       do { ODCONCbits.ODC3 = 1; } while(0)
#define LED3_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define LED3_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set IR aliases
#define IR_TRIS                 TRISCbits.TRISC7
#define IR_LAT                  LATCbits.LATC7
#define IR_PORT                 PORTCbits.RC7
#define IR_WPU                  WPUCbits.WPUC7
#define IR_OD                   ODCONCbits.ODC7
#define IR_ANS                  ANSELCbits.ANSC7
#define IR_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define IR_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define IR_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define IR_GetValue()           PORTCbits.RC7
#define IR_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define IR_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define IR_SetPullup()          do { WPUCbits.WPUC7 = 1; } while(0)
#define IR_ResetPullup()        do { WPUCbits.WPUC7 = 0; } while(0)
#define IR_SetPushPull()        do { ODCONCbits.ODC7 = 0; } while(0)
#define IR_SetOpenDrain()       do { ODCONCbits.ODC7 = 1; } while(0)
#define IR_SetAnalogMode()      do { ANSELCbits.ANSC7 = 1; } while(0)
#define IR_SetDigitalMode()     do { ANSELCbits.ANSC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/