/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.65.2
        Device            :  PIC16F1778
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.45
        MPLAB 	          :  MPLAB X 4.15	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set POT aliases
#define POT_TRIS                 TRISAbits.TRISA0
#define POT_LAT                  LATAbits.LATA0
#define POT_PORT                 PORTAbits.RA0
#define POT_WPU                  WPUAbits.WPUA0
#define POT_OD                   ODCONAbits.ODA0
#define POT_ANS                  ANSELAbits.ANSA0
#define POT_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define POT_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define POT_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define POT_GetValue()           PORTAbits.RA0
#define POT_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define POT_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define POT_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define POT_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define POT_SetPushPull()        do { ODCONAbits.ODA0 = 0; } while(0)
#define POT_SetOpenDrain()       do { ODCONAbits.ODA0 = 1; } while(0)
#define POT_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define POT_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set S2 aliases
#define S2_TRIS                 TRISAbits.TRISA6
#define S2_LAT                  LATAbits.LATA6
#define S2_PORT                 PORTAbits.RA6
#define S2_WPU                  WPUAbits.WPUA6
#define S2_OD                   ODCONAbits.ODA6
#define S2_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define S2_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define S2_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define S2_GetValue()           PORTAbits.RA6
#define S2_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define S2_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define S2_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define S2_SetPushPull()        do { ODCONAbits.ODA6 = 0; } while(0)
#define S2_SetOpenDrain()       do { ODCONAbits.ODA6 = 1; } while(0)

// get/set S1 aliases
#define S1_TRIS                 TRISAbits.TRISA7
#define S1_LAT                  LATAbits.LATA7
#define S1_PORT                 PORTAbits.RA7
#define S1_WPU                  WPUAbits.WPUA7
#define S1_OD                   ODCONAbits.ODA7
#define S1_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define S1_GetValue()           PORTAbits.RA7
#define S1_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define S1_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define S1_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define S1_SetPushPull()        do { ODCONAbits.ODA7 = 0; } while(0)
#define S1_SetOpenDrain()       do { ODCONAbits.ODA7 = 1; } while(0)

// get/set D aliases
#define D_TRIS                 TRISBbits.TRISB2
#define D_LAT                  LATBbits.LATB2
#define D_PORT                 PORTBbits.RB2
#define D_WPU                  WPUBbits.WPUB2
#define D_ANS                  ANSELBbits.ANSB2
#define D_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define D_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define D_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define D_GetValue()           PORTBbits.RB2
#define D_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define D_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define D_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define D_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define D_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define D_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set C aliases
#define C_TRIS                 TRISBbits.TRISB3
#define C_LAT                  LATBbits.LATB3
#define C_PORT                 PORTBbits.RB3
#define C_WPU                  WPUBbits.WPUB3
#define C_ANS                  ANSELBbits.ANSB3
#define C_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define C_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define C_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define C_GetValue()           PORTBbits.RB3
#define C_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define C_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define C_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define C_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define C_SetAnalogMode()      do { ANSELBbits.ANSB3 = 1; } while(0)
#define C_SetDigitalMode()     do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set B aliases
#define B_TRIS                 TRISBbits.TRISB4
#define B_LAT                  LATBbits.LATB4
#define B_PORT                 PORTBbits.RB4
#define B_WPU                  WPUBbits.WPUB4
#define B_OD                   ODCONBbits.ODB4
#define B_ANS                  ANSELBbits.ANSB4
#define B_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define B_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define B_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define B_GetValue()           PORTBbits.RB4
#define B_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define B_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define B_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define B_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define B_SetPushPull()        do { ODCONBbits.ODB4 = 0; } while(0)
#define B_SetOpenDrain()       do { ODCONBbits.ODB4 = 1; } while(0)
#define B_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define B_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set A aliases
#define A_TRIS                 TRISBbits.TRISB5
#define A_LAT                  LATBbits.LATB5
#define A_PORT                 PORTBbits.RB5
#define A_WPU                  WPUBbits.WPUB5
#define A_OD                   ODCONBbits.ODB5
#define A_ANS                  ANSELBbits.ANSB5
#define A_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define A_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define A_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define A_GetValue()           PORTBbits.RB5
#define A_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define A_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define A_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define A_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define A_SetPushPull()        do { ODCONBbits.ODB5 = 0; } while(0)
#define A_SetOpenDrain()       do { ODCONBbits.ODB5 = 1; } while(0)
#define A_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define A_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set LED aliases
#define LED_TRIS                 TRISCbits.TRISC3
#define LED_LAT                  LATCbits.LATC3
#define LED_PORT                 PORTCbits.RC3
#define LED_WPU                  WPUCbits.WPUC3
#define LED_OD                   ODCONCbits.ODC3
#define LED_ANS                  ANSELCbits.ANSC3
#define LED_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define LED_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define LED_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define LED_GetValue()           PORTCbits.RC3
#define LED_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define LED_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define LED_SetPullup()          do { WPUCbits.WPUC3 = 1; } while(0)
#define LED_ResetPullup()        do { WPUCbits.WPUC3 = 0; } while(0)
#define LED_SetPushPull()        do { ODCONCbits.ODC3 = 0; } while(0)
#define LED_SetOpenDrain()       do { ODCONCbits.ODC3 = 1; } while(0)
#define LED_SetAnalogMode()      do { ANSELCbits.ANSC3 = 1; } while(0)
#define LED_SetDigitalMode()     do { ANSELCbits.ANSC3 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/